/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBҰ
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
  #include "lib_mcu/flash/flash_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DESCRIPTOR_DEVICE,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		DESCRIPTOR_CONFIGURATION,
		Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)\
								 +sizeof(S_usb_interface_descriptor)   \
								 +sizeof(S_usb_hid_descriptor)         \
								 +sizeof(S_usb_endpoint_descriptor)    \
								 +sizeof(S_usb_interface_descriptor)   \
								 +sizeof(S_usb_endpoint_descriptor)    \
								 +sizeof(S_usb_endpoint_descriptor)    \
								 +sizeof(S_usb_interface_descriptor)   \
								 +sizeof(S_usb_hid_descriptor)         \
								 +sizeof(S_usb_endpoint_descriptor)    \
								 +sizeof(S_usb_endpoint_descriptor)),
								 NB_INTERFACE,
								 CONF_NB,
								 CONF_INDEX,
								 CONF_ATTRIBUTES,
								 MAX_POWER
	},
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		INTERFACE_NB_MOUSE,
		ALTERNATE_MOUSE,
		NB_ENDPOINT_MOUSE,
		INTERFACE_CLASS_MOUSE,
		INTERFACE_SUB_CLASS_MOUSE,
		INTERFACE_PROTOCOL_MOUSE,
		INTERFACE_INDEX_MOUSE
	},
	{
		sizeof(S_usb_hid_descriptor),
		DESCRIPTOR_HID,
		HID_BDC,
		HID_NO_COUNTRY_CODE,
		HID_CLASS_DESC_NB_DEFAULT,
		DESCRIPTOR_REPORT,
		Usb_write_word_enum_struc(sizeof(S_usb_hid_report_descriptor_mouse))
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_1,
		EP_ATTRIBUTES_1,
		Usb_write_word_enum_struc(EP_SIZE_1),
		EP_INTERVAL_1
	},
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		INTERFACE_NB,
		ALTERNATE,
		NB_ENDPOINT,
		INTERFACE_CLASS,
		INTERFACE_SUB_CLASS,
		INTERFACE_PROTOCOL,
		INTERFACE_INDEX
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_2,
		EP_ATTRIBUTES_2,
		Usb_write_word_enum_struc(EP_SIZE_2),
		EP_INTERVAL_2
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_3,
		EP_ATTRIBUTES_3,
		Usb_write_word_enum_struc(EP_SIZE_3),
		EP_INTERVAL_3
	},
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		INTERFACE_NB_HID,
		ALTERNATE,
		NB_ENDPOINT,
		INTERFACE_CLASS_HID,
		INTERFACE_SUB_CLASS_HID,
		INTERFACE_PROTOCOL_HID,
		INTERFACE_INDEX
	},
	{
		sizeof(S_usb_hid_descriptor),
		DESCRIPTOR_HID,
		HID_BDC,
		HID_NO_COUNTRY_CODE,
		HID_CLASS_DESC_NB_DEFAULT,
		DESCRIPTOR_REPORT,
		Usb_write_word_enum_struc(sizeof(S_usb_hid_report_descriptor))
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_4,
		EP_ATTRIBUTES_4,
		Usb_write_word_enum_struc(EP_SIZE_4),
		EP_INTERVAL_5
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_5,
		EP_ATTRIBUTES_5,
		Usb_write_word_enum_struc(EP_SIZE_5),
		EP_INTERVAL_5
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	DESCRIPTOR_STRING,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	DESCRIPTOR_STRING,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
#if (USB_DEVICE_SN_USE==ENABLE)
code S_usb_serial_number usb_user_serial_number =
{
#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	sizeof(usb_user_serial_number)+4*SN_LENGTH,
	DESCRIPTOR_STRING
#else
	sizeof(usb_user_serial_number),
	DESCRIPTOR_STRING,
	USB_SERIAL_NUMBER
#endif
};
#endif

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	DESCRIPTOR_STRING,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};

code S_usb_hid_report_descriptor_mouse usb_hid_report_descriptor_mouse =
{
	{
		0x05,0x01,			/* gp߰ (W޽į)     */
		0x09,0x02,			/* p@ (ϳ)                   */
		0xA1,0x01,			/* W (p)                  */
		0x09,0x01,			/* p@ (߲)                 */
		0xA1,0x00,			/* W (p)                  */
		0x05,0x09,			/* gp߰ (t)               */
		0x19,0x01,			/* gp ŏ (1)                */
		0x29,0x03,			/* _ ő (3)                */
		0x15,0x00,			/* _ ŏ (0)                */
		0x25,0x01,			/* _ ő (1)                */
		0x75,0x01,			/*  傫 (1)              */
		0x95,0x03,			/*   (3)                  */
		0x81,0x02,			/*  (ްAϐA)      */
		0x75,0x05,			/*  傫 (5)              */
		0x95,0x01,			/*   (1)                  */
		0x81,0x01,			/*  (萔)                  */
		0x05,0x01,			/* gp߰ (W޽įߐ) */
		0x09,0x30,			/* p@ X                       */
		0x09,0x31,			/* p@ Y                       */
		0x09,0x38,			/* p@                       */
		0x15,0x81,			/* _ ŏ (-127)             */
		0x25,0x7F,			/* _ ő (127)              */
		0x75,0x08,			/*  傫 (8)              */
		0x95,0x03,			/*   (3)                  */
		0x81,0x06,			/*  (ްAϐA)      */
		0xC0,				/* WI                     */
		0xC0				/* WI                     */
	}
};

code S_usb_hid_report_descriptor usb_hid_report_descriptor =
{
	{
		0x06, 0xFF, 0xFF,			// 04|2   , gp߰ (Ғ`?)
		0x09, 0x01,					// 08|1   , p@ (Ғ`)
		0xA1, 0x01,					// A0|1   , W (p)
		// IN
		0x09, 0x02,					// 08|1   , p@ (Ғ`)
		0x09, 0x03,					// 08|1   , p@ (Ғ`)
		0x15, 0x00,					// 14|1   , _ŏ (t޲Ăɑ΂0?)
		0x26 ,0xFF,0x00,			// 24|1   , _ő (t޲Ăɑ΂255?)
		0x75, 0x08,					// 74|1   , 񍐑傫(8) = ޯĂł̗̈̑傫=1޲
		0x95, LENGTH_OF_REPORT_IN,	// 94|1:ReportCount(傫) = Oڂ̌JԂ
		0x81, 0x02,					// 80|1: IN (ްAϐA)
		// OUT
		0x09, 0x04,					// 08|1   , p@ (Ғ`)
		0x09, 0x05,					// 08|1   , p@ (Ғ`)
		0x15, 0x00,					// 14|1   , _ŏ (t޲Ăɑ΂0?)
		0x26, 0xFF,0x00,			// 24|1   , _ő (t޲Ăɑ΂255?)
		0x75, 0x08,					// 74|1   , 񍐑傫(8) = ޯĂł̗̈̑傫=1޲
		0x95, LENGTH_OF_REPORT_OUT,	// 94|1:ReportCount(傫) = Oڂ̌JԂ
		0x91, 0x02,					// 90|1: OUT (ްAϐA)
		// @\
		0x09, 0x06,					// 08|1   , p@ (Ғ`)
		0x09, 0x07,					// 08|1   , p@ (Ғ`)
		0x15, 0x00,					// 14|1   , _ŏ (t޲Ăɑ΂0?)
		0x26, 0xFF,0x00,			// 24|1   , _ő (t޲Ăɑ΂255?)
		0x75, 0x08,					// 74|1   , 񍐑傫(8) = ޯĂł̗̈̑傫=1޲
		0x95, 0x04,					// 94|1:ReportCount
		0xB1, 0x02,					// B0|1: @\
		0xC0						// C0|0   , WI
	}
};
