/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBײ ٰ݂܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_drv.h"

//_____ ϸ ________________________________________________________________

//_____ 錾 _______________________________________________________________

#if (USB_DEVICE_FEATURE==DISABLED && USB_HOST_FEATURE==DISABLED)
  #error at least one of  USB_DEVICE_FEATURE or USB_HOST_FEATURE should be unabled
#endif

#if (USB_DEVICE_FEATURE == ENABLED)

//! usb_configure_endpoint
//!
//! ̊֐͑I`Ŵ߲Ă`Ԑݒ肵܂B
//!
//! @param config0
//! @param config1
//!
//! @return Is_endpoint_configured
//!
U8 usb_config_ep (U8 config0, U8 config1)
{
	Usb_enable_endpoint();
	UECFG0X = config0;
	UECFG1X = (UECFG1X & (1<<ALLOC)) | config1;
	Usb_allocate_memory();
	return (Is_endpoint_configured());
}

//! usb_select_endpoint_interrupt
//!
//! ̊֐͎ۂN߲ĂIĂ̴߲Ă̔ԍԂ܂B
//! ߲ĂŎۂNȂ΁Å֐0Ԃ܂B
//!
//! @param Ȃ
//!
//! @return ߲Ĕԍ
//!
U8 usb_select_enpoint_interrupt (void)
{
	U8 interrupt_flags;
	U8 ep_num;

	ep_num = 0;
	interrupt_flags = Usb_interrupt_flags();

	while(ep_num < MAX_EP_NB)
	{
		if (interrupt_flags & 1)
		{
			return (ep_num);
		}
		else
		{
			ep_num++;
			interrupt_flags = interrupt_flags >> 1;
		}
	}
	return 0;
}

//! usb_send_packet
//!
//! ̊֐tbufɂĎwꂽްI߲FIFOֈړUSB
//! ʂĂ𑗂܂B
//!
//! @param	ep_num		w肳ꂽ߲Ă̔ԍ
//! @param	*tbuf		ŏް̱ڽ
//! @param	data_length	޲Đ
//!
//! @return				鎟U8̱ڽ
//!
//! :
//! usb_send_packet(3,&first_data,0x20);	// ߲3߹đo
//! while(!(Usb_tx_complete));				// νĂɂčm艞߹đ҂
//! Usb_clear_tx_complete();				// M
//!
//! :
//! tbuf'data_length'܂B
//!
U8 usb_send_packet (U8 ep_num, U8* tbuf, U8 data_length)
{
	U8 remaining_length;

	remaining_length = data_length;
	Usb_select_endpoint(ep_num);
	while(Is_usb_write_enabled() && (0 != remaining_length))
	{
		Usb_write_byte(*tbuf);
		remaining_length--;
		tbuf++;
	}
	return remaining_length;
}

//! usb_read_packet
//!
//! ̊֐ʹ߲FIFOɊi[ꂽް*rbufɂĎw肳ꂽڽ
//! ړ܂B
//!
//! @param	ep_num		w肳ꂽ߲Ĕԍ
//! @param	*rbuf		USBްŏŏް̱ڽ
//! @param	data_length	ǂ܂޲Đ
//!
//! @return				鎟U8̱ڽ
//!
//! :
//! while(!(Usb_rx_complete));						// VKM߹đҋ@
//! usb_read_packet(4,&first_data,usb_get_nb_byte);	// ߲4߹ēǂݍ
//! Usb_clear_rx();									// M
//!
//! :
//! rbuf'data_length'܂B
//!
U8 usb_read_packet (U8 ep_num, U8* rbuf, U8 data_length)
{
	U8 remaining_length;

	remaining_length = data_length;
	Usb_select_endpoint(ep_num);

	while(Is_usb_read_enabled() && (0 != remaining_length))
	{
		*rbuf = Usb_read_byte();
		remaining_length--;
		rbuf++;
	}
	return remaining_length;
}

//! usb_halt_endpoint
//!
//! ̊֐͎νėvɑ΂STALL޼𑗂܂BSTALL޼̴͂
//! ߲Ăɑ΂SETUP܂͒~@\N܂ňȍ~̗vɑ܂B
//!
//! @param	ep_num	w肳ꂽ߲Ă̔ԍ
//!
//! @return	Ȃ
//!
void usb_halt_endpoint (U8 ep_num)
{
	Usb_select_endpoint(ep_num);
	Usb_enable_stall_handshake();
}

//! usb_init_device
//!
//! ̊֐USBuĊ萧߲Ă`Ԑݒ肵܂B
//!
//! @param	Ȃ
//!
//! @return	
//!
U8 usb_init_device (void)
{
	Usb_select_device();
	if(Is_usb_id_device())
	{
		Usb_select_endpoint(EP_CONTROL);
		if(!Is_usb_endpoint_enabled())
		{
#if (USB_LOW_SPEED_DEVICE==DISABLE)
			return usb_configure_endpoint(EP_CONTROL,    \
										  TYPE_CONTROL,  \
										  DIRECTION_OUT, \
										  SIZE_64,       \
										  ONE_BANK,      \
										  NYET_DISABLED);
#else
			return usb_configure_endpoint(EP_CONTROL,    \
										  TYPE_CONTROL,  \
										  DIRECTION_OUT, \
										  SIZE_8,        \
										  ONE_BANK,      \
										  NYET_DISABLED);
#endif
		}
	}
	return FALSE;
}
#endif

//! --------------------------------------------------------
//! ------------------ ν ---------------------------------
//! --------------------------------------------------------

#if (USB_HOST_FEATURE == ENABLED)

//! usb_configure_pipe
//!
//! ̊֐͑I`߲߂`Ԑݒ肵܂B
//!
//! @param	config0
//! @param	config1
//!
//! @return	Is_endpoint_configured
U8 host_config_pipe (U8 config0, U8 config1)
{
	Host_enable_pipe();
	UPCFG0X = config0;
	UPCFG1X = config1;
	Host_allocate_memory();
	return (Is_pipe_configured());
}

//! host_determine_pipe_size
//!
//! ̊֐͑u(ڑF)Ōoꂽ߲Ă̑傫ɏ]e
//! `Ԑݒڼ޽lԂ܂B
//!
//! @return	pipe	eڼ޽l
//!
U8 host_determine_pipe_size (U16 size)
{
		if(size <= 8  ) {return (SIZE_8   );}
   else if(size <= 16 ) {return (SIZE_16  );}
   else if(size <= 32 ) {return (SIZE_32  );}
   else if(size <= 64 ) {return (SIZE_64  );}
   else if(size <= 128) {return (SIZE_128 );}
   else if(size <= 256) {return (SIZE_256 );}
   else if(size <= 512) {return (SIZE_512 );}
   else                 {return (SIZE_1024);}
}

//! host_disable_all_pipe
//!
//! ̊֐νĐɊւSĂ߲߂֎~܂B
//! uؒfł̎sɗLp
//!
//! @return	Ȃ
//!
void host_disable_all_pipe (void)
{
	U8 i;
	for (i=0;i<7;i++)
	{
		Host_reset_pipe(i);
		Host_select_pipe(i);
		Host_unallocate_memory();
		Host_disable_pipe();
	}
}

//! @brief USBʐM荞݂𐶐߲ߔԍԂB
//!
//! ̊֐͊荞݂oꂽɂĂ΂ׂłBȂΕԂ
//! l͕słB
//!
//! @param	Ȃ
//!
//! @return	pipe_number
//!
U8 usb_get_nb_pipe_interrupt (void)
{
	U8 interrupt_flags;
	U8 i;

	interrupt_flags = Host_get_pipe_interrupt();
	for(i=0;i< MAX_EP_NB;i++)
	{
		if (interrupt_flags & (1<<i))
		{
			return (i);
		}
	}
	// return͌ċNׂł͂܂B
	return MAX_EP_NB+1;
}

#endif // USB_HOST_FEATURE == ENABLED
