/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBuǗ܂B
//!
//! USBƂUSBνĂ̐Vv̓𒲂ׂ܂B
//! \ݒ(SETUP)vNƁA̍Ƃusb_standard_request.çقɊ܂܂
//! 邱̍\ݒ̏Jn܂B
//! ̸׽Lv̧قŏ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_device_task.h"
#include "modules/usb/usb_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "lib_mcu/pll/pll_drv.h"
#ifdef USE_USB_AUTOBAUD
  #include "lib_mcu/wdt/wdt_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//!
//! J: (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected͂ȂFALSEɐݒ肳܂B
//!/
bit usb_connected=FALSE;

//!
//! J: (bit) usb_suspended
//! usb_suspendedUSBx~()`Ԃ̎TRUEɐݒ肳܂B
//! usb_suspended͂ȂFALSEɐݒ肳܂B
//!/
bit usb_suspended=FALSE;

//!
//! J: (U8) usb_configuration_nb
//! USBuɂĎgpUSB`Ԑݒ萔i[܂B
//! ̒l0ƈقȂ鎞ɂ͑u`Ԃ(ڑF)ꂽƂӖ܂B
//! USB_DEVICE_FEATURE == ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;

//_____ 錾 _______________________________________________________________

//!
//! @brief ̊֐USBuƼъ荞݂܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void usb_device_task_init (void)
{
	Usb_disable();
	Usb_enable();
#if (VBUS_SENSING_IO == ENABLED)
	Usb_vbus_sense_init();					// VBUSmɎgpI/O
#endif
}

//!
//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//! u@\̊JnVBUSω荞݂܂VBUSHighق̂ǂ炩ɂĈU
//! VBUSڑoƎs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_start_device (void)
{
	Usb_freeze_clock();
#ifndef USE_USB_AUTOBAUD
	Pll_start_auto();
#else
	usb_autobaud();
#endif
	Wait_pll_ready();
	Disable_interrupt();
	Usb_unfreeze_clock();
	Usb_attach();
#if (USB_RESET_CPU == ENABLED)
	Usb_reset_all_system();
#else
	Usb_reset_macro_only();
#endif
	usb_init_device();						// USB߲0`Ԑݒ
	Usb_enable_suspend_interrupt();
	Usb_enable_reset_interrupt();
	Enable_interrupt();
}

//! @brief USBuǗ̓_
//!
//! ̊֐USBǗ̓_łBeUSBۂ͓K؂ȊJn邽߂ɂ
//! ׂ܂B萧߲Ăō\ݒ(SETUP)vNꍇA
//! usb_process_request()֐usb_standard_request.çٓĂт܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_device_task (void)
{
	if (usb_connected == FALSE)
	{
#if (VBUS_SENSING_IO == ENABLED)
		if (Is_usb_vbus_on())				// t̂߂VBUS ON
		{
			Usb_enable();
			usb_connected = TRUE;
			usb_start_device();
			Usb_vbus_on_action();
		}
#else
		usb_connected = TRUE;				// pȋdłȂΕt
		usb_start_device();
		Usb_vbus_on_action();
#endif
	}

#if (VBUS_SENSING_IO == ENABLED)
	if ((usb_connected == TRUE) && Is_usb_vbus_off())	// t̂VBUS OFF
	{
		Usb_detach();
		Usb_disable();
		Stop_pll();
		usb_connected = FALSE;
		usb_configuration_nb=0;
	}
#endif

	if(Is_usb_event(EVT_USB_RESET))
	{
		Usb_ack_event(EVT_USB_RESET);
		Usb_reset_endpoint(0);
		usb_configuration_nb=0;
	}

	// őu(ڑF)̂߂̐ڑ
	Usb_select_endpoint(EP_CONTROL);
	if (Is_usb_receive_setup())
	{
		usb_process_request();
	}
}


#ifdef USE_USB_AUTOBAUD
#warning CAUTION Preliminary USB autobaud for USB DFU bootloader Only... 
//! @brief USBuްڰ
//!
//! ̊֐USB̪ɑ΂ĎްڰČ`Ԑݒs܂BްڰĊ֐
//! USB̪pPLĽ`Ԑݒs܂BްڰĎZ@͐ڰъJn
//! (SOF)̌o܂ŊeUSB PLL̎s琬܂B
//!
//! @warning Code:??޲(֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_autobaud (void)
{
	U16 count_rc=0;

	volatile U16 tempo;

	wdtdrv_interrupt_enable(WDTO_16MS);
	TCCR1B=0x00; TCCR1A=0x00;
	TCNT1=0x00;  TIFR1=0x01;				//! T/C1׸ނTCNT1l

	TCCR1B|=(1<<CS01) |(1<<CS00);			// 2OuClkIO/64XTAL/128
	WDTCKD|=(1<<WDEWIE);
	while(Is_not_wdt_early_warning());
	TCCR1B=0;
	wdtdrv_disable();
	WDTCKD|=(1<<WDEWIF);					// x׸މ
	WDTCKD=0;

	count_rc=TCNT1;
	TCCR1B=0x00; TCCR1A=0x00;
	TCNT1=0x00;  TIFR1=0x01;				//! T/C1׸ނTCNT1l
	if(count_rc>1500)						// 16msޯނ16MHz/1282000v^܂B
	{
		Start_pll(PLLx03);					//! FOSC 16MHz
	}
	else
	{
		Start_pll(PLLx06);					//! FOSC 8MHz
	}
}
#endif
