/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قSCSIłB
//!
//! ̧قSCSI߂̕ƊǗٰ݂܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "scsi_decoder.h"
#include "storage_task.h"
#include "conf_usb.h"
#include "lib_mcu/usb/usb_drv.h"
#include "modules/control_access/ctrl_status.h"
#include "modules/control_access/ctrl_access.h"

//_____ ` _______________________________________________________________

U8  g_scsi_command[16];
U8  g_scsi_status;
U32 g_scsi_data_remaining;

code U8 g_sbc_vendor_id[8]   = SBC_VENDOR_ID;
code U8 g_sbc_product_id[16] = SBC_PRODUCT_ID;
code U8 g_sbc_revision_id[4] = SBC_REVISION_ID;

extern U8  usb_LUN;
extern bit ms_data_direction;
s_scsi_sense g_scsi_sense;

code struct sbc_st_std_inquiry_data sbc_std_inquiry_data =
{
	// ޲0 : 0x00
	0x00,		// DeviceType : ڱu(SBC)
	0,			// PeripheralQualifier : ݐڑς

	// ޲1 : 0x80
	0,			// Reserved1
	1,			// RMB : }͎̂O(ޯĂ1łȂ΂Ȃ炸AȂWindows}̂͌܂B)

	// ޲2 : DeviceType̖߂̑gɑΉVERSION̕(ł͒ڱu-SBC)
	0x03,		// - 00H u͂ǂ̕Wɑ΂ĂK߂܂B
				// - 03H uSPCɓK(=SBC)
				// - 04H uSPC-2ɓK(=SBC-2)
				// - 05H uSPC-3ɓK(=SBC-2)
				// - 06H uSPC-4ɓK(=SBC-3)

	// ޲3 : 0x02
	2,			// ް`
	0,			// NormACA
	0,			// Obsolete0
	0,			// AERC

	// ޲4 : 0x1F
	// ޲5 : 0x00
	// ޲6 : 0x00
				// Reserved4[3]
	{
		0x1F,	// ǉ(n-4)
		0,		// SCCS : SCCx
		0
	},

	// ޲7 : 0x00
	0,			// SoftReset
	0,			// CommandQueue
	0,			// Reserved5
	0,			// LinkedCommands
	0,			// Synchronous
	0,			// Wide16Bit
	0,			// Wide32Bit
	0,			// RelativeAddressing
};

static void send_informational_exceptions_page  (void);
static void send_read_write_error_recovery_page (U8);
static void sbc_header_mode_sense               (Bool b_sense_10, U8 u8_data_length);

//_____ 錾 _______________________________________________________________

/**
 * @brief SCSI֐
 *
 * ̊֐SCSI߂ǂœK؂Ȋ֐Jn܂B
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
Bool scsi_decode_command (void)
{
	Bool status;

	if (g_scsi_command[0] == SBC_CMD_WRITE_10)
	{
		Scsi_start_write_action();
		status = sbc_write_10();
		Scsi_stop_write_action();
		return status;
	}
	if (g_scsi_command[0] == SBC_CMD_READ_10 )
	{
		Scsi_start_read_action();
		status = sbc_read_10();
		Scsi_stop_read_action();
		return status;
	}

	switch (g_scsi_command[0])
	{
		case SBC_CMD_REQUEST_SENSE:			// 0x03 - K{
			return sbc_request_sense();
			break;

		case SBC_CMD_INQUIRY:				// 0x12 - K{
			return sbc_inquiry();
			break;

		case SBC_CMD_TEST_UNIT_READY:		// 0x00 - K{
			return sbc_test_unit_ready();
			break;

		case SBC_CMD_READ_CAPACITY:			// 0x25 - K{
			return sbc_read_capacity();
			break;

		case SBC_CMD_MODE_SENSE_6:			// 0x1A - CӑI
			return sbc_mode_sense( FALSE );
			break;

		case SBC_CMD_PREVENT_ALLOW_MEDIUM_REMOVAL:	// 0x1E
			return sbc_prevent_allow_medium_removal();
			break;

		case SBC_CMD_VERIFY_10:				// 0x2F - CӑI
			sbc_lun_status_is_good();
			break;

		case SBC_CMD_MODE_SENSE_10:			// 0x5A - CӑI
			return sbc_mode_sense( TRUE );
			break;

		case SBC_CMD_START_STOP_UNIT:		// 0x1B - CӑIłA̖߂Linux 2.4قɂĎgp邽߂ɖ܂B
			sbc_lun_status_is_good();		// ߂ԓłAȂި͐t܂B
			break;

		case SBC_CMD_FORMAT_UNIT:			// 0x04 - K{
		case SBC_CMD_MODE_SELECT_6:			// 0x15 - CӑI
		case SBC_CMD_SEND_DIAGNOSTIC:		// 0x1D - 
		case SBC_CMD_READ_LONG:				// 0x23 - CӑI
		case SBC_CMD_SYNCHRONIZE_CACHE:		// 0x35 - CӑI
		case SBC_CMD_WRITE_BUFFER:			// 0x3B - CӑI
		case SBC_CMD_RESERVE_10:			// 0x56 - K{
		case SBC_CMD_RELEASE_10:			// 0x57 - K{ - SPC-2dl7.16߂B
		default:
			// xȂ
			Sbc_send_failed();
			Sbc_build_sense(SBC_SENSE_KEY_ILLEGAL_REQUEST, SBC_ASC_INVALID_COMMAND_OPERATION_CODE, 0x00);
			return FALSE;
			break;
	}
	return TRUE;
}

/**
 * @brief ̊֐SCSIvm(0x03)Ǘ܂B
 *
 * SCSIm͍Ō̖߂̏Ԃ܂݂܂B
 * ̏Ԃ͈ȉ3޲Ă琬܂B
 * - m(g_scsi_sense.key)
 * - ǉm(g_scsi_sense.asc)
 * - ǉmCq(g_scsi_sense.ascq)
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
Bool sbc_request_sense (void)
{
	U8 allocation_length, i;
	U8 request_sens_output[18];				// v̍őʂ17łB

	allocation_length = g_scsi_command[4];	// 蓖Ē
	if( allocation_length > 18 )
	{
		allocation_length = 18;
	}
	// vmް
	request_sens_output[0] = SBC_RESPONSE_CODE_SENSE;	// 70H
	request_sens_output[1] = 0x00;			// ()
	request_sens_output[2] = g_scsi_sense.key;

	request_sens_output[3] = 0x00;			// ڱ}̂ɑ΂āÄ
	request_sens_output[4] = 0x00;			// Ȃ_^B
	request_sens_output[5] = 0x00;			// mƘAgڽ
	request_sens_output[6] = 0x00;

	request_sens_output[7] = SBC_ADDITIONAL_SENSE_LENGTH;	// UFIu͐؂𔽉f邽߂ɒǉm𒲐Ȃł傤B
	request_sens_output[8] = SBC_COMMAND_SPECIFIC_INFORMATION_3;
	request_sens_output[9] = SBC_COMMAND_SPECIFIC_INFORMATION_2;
	request_sens_output[10] = SBC_COMMAND_SPECIFIC_INFORMATION_1;
	request_sens_output[11] = SBC_COMMAND_SPECIFIC_INFORMATION_0;

	request_sens_output[12] = g_scsi_sense.asc;
	request_sens_output[13] = g_scsi_sense.ascq;

	request_sens_output[14] = SBC_FIELD_REPLACEABLE_UNIT_CODE;
	request_sens_output[15] = SBC_SENSE_KEY_SPECIFIC_2;
	request_sens_output[16] = SBC_SENSE_KEY_SPECIFIC_1;
	request_sens_output[17] = SBC_SENSE_KEY_SPECIFIC_0;

	// vް𑗏o
	for( i=0 ; i<allocation_length ; i++ )
	{
		Usb_write_byte( request_sens_output[i] );
	}
	Sbc_valid_write_usb( allocation_length );

	sbc_lun_status_is_good();
	return TRUE;
}

/**
 * @brief ̊֐SCSI₢킹(0x12)Ǘ܂B
 *
 * SCSI₢킹͖̈ڕWҰɊւ܂݂܂B
 * - Ҏ
 * - i
 * - Ӌ@\Cq
 * - Ӌ@\u`
 * - Ȃ
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
Bool sbc_inquiry (void)
{
	U8 allocation_length, i;

#ifdef __GNUC__
	PGM_VOID_P ptr;
#else
	U8 code *ptr;
#endif

	if( (0 != (g_scsi_command[1] & 0x03) )	// CMDTEPVDޯĂ0
	 || (0 !=  g_scsi_command[2] ) )		// PAGE܂OPERATION CODË̗=0x00?
	{
		// (CMDT=EVPD <> 0)܂(PAGE CODE <> 0x00)
		// ꂽW₢킹Ȃ
		sbc_lun_status_is_cdb_field();
		return FALSE;
	}

	// W₢킹߂Ǘ
	// ₢킹ް̑傫
	allocation_length = g_scsi_command[4];
	if (allocation_length > SBC_MAX_INQUIRY_DATA)
	{
		allocation_length = SBC_MAX_INQUIRY_DATA;
	}

	// ŏ̖₢킹ްo(0`8)
	ptr = (code U8*) &sbc_std_inquiry_data;

	for ( i=0 ; ((i != 36) && (allocation_length > i)); i++)
	{
		if( 8 == i )
		{	// IDo(8`16)
			ptr = (code U8 *) &g_sbc_vendor_id;
		}
		if( 16 == i )
		{	// iIDo(16`32)
			ptr = (code U8 *) &g_sbc_product_id;
		}
		if( 32 == i )
		{	// IDo(32`36)
			ptr = (code U8 *) &g_sbc_revision_id;
		}
#ifndef __GNUC__
		Usb_write_byte((U8)(*ptr++));
#else // AVRGCCPGMԂւ̎wx܂B
// x:AVRGCCőuLqqߏׯ ؂̉ʑ64K޲ĂɊi[Ƃ̉łB
		Usb_write_byte(pgm_read_byte_near((unsigned int)ptr++));
#endif

	}
	Sbc_valid_write_usb(i);
	sbc_lun_status_is_good();
	return TRUE;
}

Bool sbc_test_unit_ready (void)
{
	switch ( mem_test_unit_ready(usb_LUN) )
	{
		case CTRL_GOOD:
			sbc_lun_status_is_good();
			break;

		case CTRL_NO_PRESENT:
			sbc_lun_status_is_not_present();
			break;

		case CTRL_BUSY:
			sbc_lun_status_is_busy_or_change();
			break;

		case CTRL_FAIL:
		default:
			sbc_lun_status_is_fail();
			break;
	}
	return TRUE;
}

Bool sbc_read_capacity (void)
{
	U32 mem_size_nb_sector;

	switch ( mem_read_capacity( usb_LUN, &mem_size_nb_sector ) )
	{
		case CTRL_GOOD:
			Usb_write_byte(MSB0(mem_size_nb_sector));	// 򐔂ԂB
			Usb_write_byte(MSB1(mem_size_nb_sector));
			Usb_write_byte(MSB2(mem_size_nb_sector));
			Usb_write_byte(MSB3(mem_size_nb_sector));
			Usb_write_byte( 0               );			// e(=512޲)ԂB
			Usb_write_byte( 0               );
			Usb_write_byte( (U8)(512 >> 8)  );
			Usb_write_byte( (U8)(512 & 0xFF));

			Sbc_valid_write_usb(SBC_READ_CAPACITY_LENGTH);
			sbc_lun_status_is_good();
			return TRUE;
			break;

		case CTRL_NO_PRESENT:
			sbc_lun_status_is_not_present();
			break;

		case CTRL_BUSY:
			sbc_lun_status_is_busy_or_change();
			break;

		case CTRL_FAIL:
		default :
			sbc_lun_status_is_fail();
			break;
	}
	return FALSE;
}

Bool sbc_read_10 (void)
{
	U32 mass_addr;							// ǂ݂܂͏ڽ
	U16 mass_size;							// ǂ݂܂͏

	MSB0(mass_addr) = g_scsi_command[2];	// ڽǂݍ
	MSB1(mass_addr) = g_scsi_command[3];
	MSB2(mass_addr) = g_scsi_command[4];
	MSB3(mass_addr) = g_scsi_command[5];

	MSB(mass_size) = g_scsi_command[7];		// eʓǂݍ
	LSB(mass_size) = g_scsi_command[8];

	if( Is_usb_ms_data_direction_out() )
	{
		sbc_lun_status_is_cdb_field();
		return FALSE;
	}
	if( 0 == g_scsi_data_remaining )
	{
		if( mass_size == (g_scsi_data_remaining/512) )
		{
			sbc_lun_status_is_good();
		}else{
			sbc_lun_status_is_cdb_field();
		}
		return TRUE;
	}

	switch ( memory_2_usb( usb_LUN , mass_addr,  g_scsi_data_remaining/512 ) )
	{
		case CTRL_GOOD:
			if( mass_size == (g_scsi_data_remaining/512) )
			{
				sbc_lun_status_is_good();
			}else{
				sbc_lun_status_is_cdb_field();
			}
			g_scsi_data_remaining = 0;
			break;

		case CTRL_NO_PRESENT:
			sbc_lun_status_is_not_present();
			return FALSE;
			break;

		case CTRL_BUSY:
			sbc_lun_status_is_busy_or_change();
			return FALSE;
			break;

		case CTRL_FAIL:
		default:
			sbc_lun_status_is_fail();
			return FALSE;
			break;
	}
	return TRUE;
}

Bool sbc_write_10 (void)
{
	U32 mass_addr;							// ǂ݂܂͏ڽ
	U16 mass_size;							// ǂ݂܂͏

	MSB0(mass_addr) = g_scsi_command[2];	// ڽǂݍ
	MSB1(mass_addr) = g_scsi_command[3];
	MSB2(mass_addr) = g_scsi_command[4];
	MSB3(mass_addr) = g_scsi_command[5];

	MSB(mass_size) = g_scsi_command[7];		// eʓǂݍ
	LSB(mass_size) = g_scsi_command[8];

	if( Is_usb_ms_data_direction_in() )
	{
		sbc_lun_status_is_cdb_field();
		return FALSE;
	}

	if( 0 == g_scsi_data_remaining )
	{
		if( mass_size == (g_scsi_data_remaining/512) )
		{
			sbc_lun_status_is_good();
		}else{
			sbc_lun_status_is_cdb_field();
		}
		return TRUE;
	}

	if( TRUE == mem_wr_protect( usb_LUN ) )
	{
		sbc_lun_status_is_protected();
		return FALSE;
	}

	switch (usb_2_memory( usb_LUN , mass_addr, g_scsi_data_remaining/512 ))
	{
		case CTRL_GOOD:
			if( mass_size == (g_scsi_data_remaining/512) )
			{
				sbc_lun_status_is_good();
			}else{
				sbc_lun_status_is_cdb_field();
			}
			g_scsi_data_remaining = 0;
			break;

		case CTRL_NO_PRESENT:
			sbc_lun_status_is_not_present();
			return FALSE;
			break;

		case CTRL_BUSY:
			sbc_lun_status_is_busy_or_change();
			return FALSE;
			break;

		case CTRL_FAIL:
		default:
			sbc_lun_status_is_fail();
			return FALSE;
			break;
	}
	return TRUE;
}

/**
 * @brief ̊֐SCSI`Ԋm(m6ɑ΂0x1AƊm10ɑ΂0x5A)Ǘ܂B
 *
 * SCSI`Ԋm֐͉pp҂ҰԂ܂B
 * SCSI`ԑI𖽗߂ɑ΂鑊ݕ⊮߂łB
 *
 * @warning	:..޲ (֐ޒ)
 *
 * @param	b_sens_10	(TRUE=m10AFALSE=m6)
 *
 * @return	FALSE:		KO(NG)
 *			TRUE:		OK
 *
 */
Bool sbc_mode_sense (Bool b_sense_10)
{
	U8 allocation_length;

	if( b_sense_10 )
		allocation_length = g_scsi_command[8];
	else
		allocation_length = g_scsi_command[4];

	// ߰ޕɊւswitch
	switch ( g_scsi_command[2] & SBC_MSK_PAGE_CODE )
	{
		case SBC_PAGE_CODE_INFORMATIONAL_EXCEPTIONS:
			sbc_header_mode_sense( b_sense_10 , SBC_MODE_DATA_LENGTH_INFORMATIONAL_EXCEPTIONS );
			send_informational_exceptions_page();
			Sbc_valid_write_usb(SBC_MODE_DATA_LENGTH_INFORMATIONAL_EXCEPTIONS + 1);
			break;

		case SBC_PAGE_CODE_READ_WRITE_ERROR_RECOVERY:
			sbc_header_mode_sense( b_sense_10 , SBC_MODE_DATA_LENGTH_READ_WRITE_ERROR_RECOVERY );
			send_read_write_error_recovery_page(allocation_length);
			Sbc_valid_write_usb(SBC_MODE_DATA_LENGTH_READ_WRITE_ERROR_RECOVERY + 1);
			break;

		case SBC_PAGE_CODE_ALL:
			if( b_sense_10 ) {
				sbc_header_mode_sense( b_sense_10 , (allocation_length < (SBC_MODE_DATA_LENGTH_CODE_ALL+2))? (allocation_length-2) : SBC_MODE_DATA_LENGTH_CODE_ALL );
			}else{
				sbc_header_mode_sense( b_sense_10 , (allocation_length < (SBC_MODE_DATA_LENGTH_CODE_ALL+1))? (allocation_length-1) : SBC_MODE_DATA_LENGTH_CODE_ALL );
			}
			if( b_sense_10 )
			{
				if (allocation_length == 8)
				{
					Sbc_valid_write_usb(8);
					break;
				}
			}
			else
			{
				if (allocation_length == 4)
				{
					Sbc_valid_write_usb(4);
					break;
				}
			}
			// ɂ߰ޑo
			send_read_write_error_recovery_page(allocation_length);	// 12޲
			if (allocation_length > 12)
			{
				send_informational_exceptions_page();	// 12޲
				Sbc_valid_write_usb(SBC_MODE_DATA_LENGTH_CODE_ALL + 1);
			}
			else
			{
				Sbc_valid_write_usb(allocation_length);
			}
			break;

		default:
			sbc_lun_status_is_cdb_field();
			return FALSE;
			break;
	}
	sbc_lun_status_is_good();
	return TRUE;
}

/**
 * @brief ̊֐SCSI`Ԋm߂̐擪𑗂܂B
 *
 * @param	b_sens_10		(TRUE=m10AFALSE=m6)
 * @param	u8_data_length	(޲Ăłް)
 *
 */
void sbc_header_mode_sense (Bool b_sense_10, U8 u8_data_length)
{
	// ްo
	if( b_sense_10 )
	{
		Usb_write_byte(0);
	}
	Usb_write_byte( u8_data_length );

	// u`o
	Usb_write_byte(SBC_MEDIUM_TYPE);

	// ݕی
	if (mem_wr_protect( usb_LUN ))
	{
		Usb_write_byte(SBC_DEV_SPEC_PARAM_WR_PROTECT);	// u͏ݕی
	}
	else
	{
		Usb_write_byte(SBC_DEV_SPEC_PARAM_WR_ENABLE);	// u͏݋
	}

	if( b_sense_10 )
	{	// (\)
		Usb_write_byte(0);
		Usb_write_byte(0);
	}

	// Lqqo
	if( b_sense_10 )
	{
		Usb_write_byte(0);
	}
	Usb_write_byte(SBC_BLOCK_DESCRIPTOR_LENGTH);
}

/**
 * @brief ̊֐͏̗O߰ Ұ܂B
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
void send_informational_exceptions_page (void)
{
	Usb_write_byte(SBC_PAGE_CODE_INFORMATIONAL_EXCEPTIONS);		// ߰ޕ:̗O߰
																// SPC-2dl8.3.8߂B
	Usb_write_byte(SBC_PAGE_LENGTH_INFORMATIONAL_EXCEPTIONS);	// ߰ޒ
	Usb_write_byte(0x00);					// ..., ޯ=0, ...
	Usb_write_byte(SBC_MRIE);				// MRIE=0x05
	Usb_write_byte(0x00);					// Ԋuv(MSB)
	Usb_write_byte(0x00);
	Usb_write_byte(0x00);
	Usb_write_byte(0x00);					// Ԋuv(LSB)
	Usb_write_byte(0x00);					// 񍐐(MSB)
	Usb_write_byte(0x00);
	Usb_write_byte(0x00);
	Usb_write_byte(0x01);					// 񍐐(LSB)
}

/**
 * @brief ̊֐ُ͈߰ނ܂B
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
void send_read_write_error_recovery_page (U8 length)
{
	Usb_write_byte(SBC_PAGE_CODE_READ_WRITE_ERROR_RECOVERY);

	Usb_write_byte(SBC_PAGE_LENGTH_READ_WRITE_ERROR_RECOVERY);	// ߰ޒ
	Usb_write_byte(0x80);
	Usb_write_byte(SBC_READ_RETRY_COUNT);
	Usb_write_byte(SBC_CORRECTION_SPAN);
	Usb_write_byte(SBC_HEAD_OFFSET_COUNT);
	Usb_write_byte(SBC_DATA_STROBE_OFFSET);
	Usb_write_byte(0x00);					// (\)

	if (length > 12)
	{
		Usb_write_byte(SBC_WRITE_RETRY_COUNT);
		Usb_write_byte(0x00);
		Usb_write_byte(SBC_RECOVERY_LIMIT_MSB);
		Usb_write_byte(SBC_RECOVERY_LIMIT_LSB);
	}
}

/**
 * @brief ̊֐SCSI}̎Oh~(0x1E)Ǘ܂B
 *
 * SCSI}̎Oh~߂͖ڕW_PʕŔ}̂̎O܂
 * ֎~邱Ƃv܂B
 *
 * @warning	:..޲(֐ޒ)
 *
 * @param	Ȃ
 *
 * @return	FALSE:	KO(NG)
 *			TRUE:	OK
 *
 */
Bool sbc_prevent_allow_medium_removal (void)
{
	sbc_lun_status_is_good();
	return TRUE;
}

//! ̊֐UFIԗǍD𑗂܂B
//!
void sbc_lun_status_is_good (void)
{
	Sbc_send_good();
	Sbc_build_sense(SBC_SENSE_KEY_NO_SENSE, SBC_ASC_NO_ADDITIONAL_SENSE_INFORMATION, 0x00);
}

//! ̊֐UFI"LUNs"𑗂܂B
//!
void sbc_lun_status_is_not_present (void)
{
	Sbc_send_failed();
	Sbc_build_sense(SBC_SENSE_KEY_NOT_READY, SBC_ASC_MEDIUM_NOT_PRESENT, 0x00);
}

//! ̊֐UFIԑZƕύX𑗂܂B
//!
void sbc_lun_status_is_busy_or_change (void)
{
	Sbc_send_failed();
	Sbc_build_sense(SBC_SENSE_KEY_UNIT_ATTENTION, SBC_ASC_NOT_READY_TO_READY_CHANGE, 0x00 );
}

//! ̊֐UFIԎs𑗂܂B
//!
void sbc_lun_status_is_fail (void)
{
	Sbc_send_failed();
	Sbc_build_sense(SBC_SENSE_KEY_HARDWARE_ERROR, SBC_ASC_NO_ADDITIONAL_SENSE_INFORMATION, 0x00);
}

//! ̊֐͏ݕی̂߂UFIԎs𑗂܂B
//!
void sbc_lun_status_is_protected (void)
{
	Sbc_send_failed();
	Sbc_build_sense(SBC_SENSE_KEY_DATA_PROTECT, SBC_ASC_WRITE_PROTECTED, 0x00);
}

//! ̊֐CDB̈悪̂߂UFIԎs𑗂܂B
//!
void sbc_lun_status_is_cdb_field (void)
{
	Sbc_send_failed();
	Sbc_build_sense(SBC_SENSE_KEY_ILLEGAL_REQUEST, SBC_ASC_INVALID_FIELD_IN_CDB, 0x00);
}
